# yamllint disable
# License: MIT (c) GitLab Inc.
# yamllint enable
---
rules:
- id: "python/escaping/rule-jinja2_autoescape_false"
  languages:
  - "python"
  message: |
    Detected a Jinja2 environment without autoescaping. Jinja2 does notautoescape by default. This
    is dangerous if you are rendering to a browserbecause this allows for cross-site scripting
    (XSS)
    attacks.  If you are ina web context, enable autoescaping by setting `autoescape=True`. You
    may also consider using `jinja2.select_autoescape()` to only enable automatic escaping for
    certain file
    extensions.
  metadata:
    cwe: "CWE-116"
    owasp: "A7:2017-Cross-Site Scripting (XSS)"
    shortDescription: "Improper Encoding or Escaping of Output"
  patterns:
  - pattern-not: "jinja2.Environment(..., autoescape=True, ...)"
  - pattern-not: "jinja2.Environment(..., autoescape=jinja2.select_autoescape(...),
      ...)"
  - pattern: "jinja2.Environment(...)"
  severity: "WARNING"
